declare filename "levelrider_stereo.dsp"; declare name "levelrider_stereo"; declare name 		"Level Rider";
declare version 	"1.0";
declare author 		"Evermind";
declare license 	"BSD";
declare copyright 	"(c) Evermind 2021";

//-----------------------------------------------
// 			Volume control in dB
//-----------------------------------------------

import("stdfaust.lib");

envelop			= abs : max(ba.db2linear(-70)) : ba.linear2db : min(10)  : max ~ -(80.0/ma.SR);

//get desired level in db and convert to linear
target		= vslider("h:[1]Config/[0][unit:dB]Target", 0, -40, +4, 0.1) : ba.db2linear : si.smoo;

//get desired speed
sec_time_window  = vslider("h:[1]Config/[1][unit:ms]Speed", 100, 1, 2000, 1) : /(1000);
samp_time_window = sec_time_window : ba.sec2samp;

//get max change
maxchange   = vslider("h:[1]Config/[2][unit:dB]Max change", 3, 0, 20, 0.01) : ba.db2linear : si.smoo;

//get current level, RMS
current_rms(x) = _ <: attach(_, envelop(_) : hbargraph("v:[0]Input/[unit:dB]%x", -70, 10)) : ba.slidingRMS(samp_time_window);

//calculate desired change
desired_change(x) = target /(current_rms(x));

//calculate actual change
actual_change(x) = min(maxchange,desired_change(x)) : max(1/maxchange) <: attach(_,ba.linear2db : hbargraph("v:[2]Adjustment/[unit:dB]",-20,20));

process		= vgroup("Adjustment",par(x,2, _ <: * (actual_change(x))));